<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
$plugin = EOS_DP_PLUGIN_BASE_NAME;
define( 'EOS_DP_DOCUMENTATION_URL','https://freesoul-deactivate-plugins.com/documentation/' );
if( eos_dp_is_fdp_page() ){
	$dir = EOS_DP_PLUGIN_DIR.'/admin/templates/';
	require_once $dir.'partials/eos-dp-navigation.php';
	require_once $dir.'partials/eos-dp-table-head.php';
	require_once $dir.'partials/eos-dp-footer.php';
	foreach( array(
		array( array( 'eos_dp_home','eos_dp_menu' ),'pages/eos-dp-singles.php' ),
		array( array( 'eos_dp_by_post_type' ),'pages/eos-dp-post-type.php' ),
		array( array( 'eos_dp_by_archive' ),'pages/eos-dp-archive.php' ),
		array( array( 'eos_dp_by_term_archive' ),'pages/eos-dp-terms-archive.php' ),
		array( array( 'eos_dp_mobile' ),'pages/eos-dp-mobile.php' ),
		array( array( 'eos_dp_search' ),'pages/eos-dp-search.php' ),
		array( array( 'eos_dp_url' ),'pages/eos-dp-url.php' ),
		array( array( 'eos_dp_admin_url' ),'pages/eos-dp-backend-url.php' ),
		array( array( 'eos_dp_integration' ),'pages/eos-dp-integration.php' ),
		array( array( 'eos_dp_admin' ),'pages/eos-dp-backend.php' ),
		array( array( 'eos_dp_smoke_tests' ),'pages/eos-dp-smoke-tests.php' ),
		array( array( 'eos_dp_firing_order' ),'pages/eos-dp-firing-order.php' ),
		array( array( 'eos_dp_help' ),'pages/eos-dp-help.php' ),
		array( array( 'eos_dp_create_plugin' ),'pages/eos-dp-create-plugin.php' ),
		array( array( 'eos_dp_favorite_plugins' ),'pages/eos-dp-favorite-plugins.php' ),
		array( array( 'eos_dp_roles_manager' ),'pages/eos-dp-roles-manager.php' )
	) as $arr ){
		if( isset( $_GET['page'] ) && in_array( $_GET['page'],$arr[0] ) ){
			require_once $dir.$arr[1];
		}
	}
	if( defined( 'FDP_BETA_VERSION' ) && FDP_BETA_VERSION && defined( 'FDP_REMOTE_HELP' ) && FDP_REMOTE_HELP ){
		require_once $dir.'pages/eos-dp-advanced-support.php';
	}
}

//It adds a settings link to the action links in the plugins page
add_filter( "plugin_action_links_$plugin", 'eos_dp_plugin_add_settings_link' );

//It redirects to the plugin settings page on successfully plugin activation
add_action( 'admin_init', 'eos_dp_redirect_to_settings' );

//It displays the admin notices
add_action( 'admin_notices','eos_dp_admin_notices',100 );

//It adds the plugin setting page under plugins menu
add_action( 'admin_menu','eos_dp_options_page',999 );

add_filter( 'admin_title', 'eos_dp_admin_page_title',99, 2 );
//It set the browser tab title depending the options page
function eos_dp_admin_page_title( $title,$sep ){
	$titles = array(
		'eos_dp_by_post_type' => __( 'Disable plugins | Post Types','eos-dp' ),
		'eos_dp_menu' => __( 'Disable plugins | Singles','eos-dp' ),
		'eos_dp_by_archive' => __( 'Disable plugins | Archives','eos-dp' ),
		'eos_dp_by_term_archive' => __( 'Disable plugins | Terms Archives','eos-dp' ),
		'eos_dp_mobile' => __( 'Disable plugins | Mobile','eos-dp' ),
		'eos_dp_search' => __( 'Disable plugins | Search','eos-dp' ),
		'eos_dp_url' => __( 'Disable plugins | URL','eos-dp' ),
		'eos_dp_admin_url' => __( 'Disable plugins | Admin URL','eos-dp' ),
		'eos_dp_admin' => __( 'Disable plugins | Back-end','eos-dp' ),
		'eos_dp_documentation' => __( 'FDP Documentation','eos-dp' ),
		'eos_dp_firing_order' => __( 'FDP Firing Order','eos-dp' ),
		'eos_dp_create_plugin' => __( 'New Plugin','eos-dp' ),
		'eos_dp_favorite_plugins' => __( 'Favorite Plugins','eos-dp' ),
		'eos_dp_smoke_tests' => __( 'Plugin Tests','eos-dp' ),
	);
	if( isset( $_GET['page'] ) && in_array( $_GET['page'],array_keys( $titles ) ) ){
		if( isset( $_GET['eos_dp_home'] ) && 'true' === $_GET['eos_dp_home'] ) return __( 'Disable plugins | Homepage','eos-dp' );
			return esc_html( $titles[$_GET['page']] );
	}
	if( isset( $_GET['eos_dp_info'] ) && 'true' == $_GET['eos_dp_info'] ){
		if( isset( $_GET['plugin'] ) ){
			return __( 'Plugin Details','eos-dp' );
		}
	}
	return $title;
}

//Remove other admin notices on the settings pages
function eos_dp_remove_other_admin_notices(){
	remove_all_actions( 'admin_notices' );
	remove_all_actions( 'all_admin_notices' );
	add_action( 'admin_notices','eos_dp_admin_notices' );
}

if( isset( $_GET['page'] ) && in_array( $_GET['page'],array( 'eos_dp_admin','eos_dp_ajax','eos_dp_integration' ) ) ){
	add_action( 'eos_dp_after_table_head_columns','eos_dp_add_theme_to_table_head' );
}
//It adds the theme column in the table header
function eos_dp_add_theme_to_table_head(){
	$theme = wp_get_theme();
	if( !is_object( $theme ) ) return;
	$theme_name = strtoupper( $theme->get( 'Name' ) );
	$theme_name_short = substr( $theme_name,0,28 );
	$theme_name_short = $theme_name === $theme_name_short ? $theme_name : strtoupper( $theme_name_short ).' ...';
	?>
	<th class="eos-dp-name-th eos-dp-name-th-theme">
		<div>
			<div id="eos-dp-theme-name" class="eos-dp-theme-name" data-theme="<?php echo esc_attr( $theme->get( 'TextDomain' ) ); ?>" title="<?php echo esc_attr( $theme_name ); ?>" data-path="<?php echo get_stylesheet_directory_uri(); ?>">
				<span><?php echo esc_html( $theme_name_short ); ?></span>
			</div>
			<div id="eos-dp-global-chk-col-wrp" class="eos-dp-global-chk-col-wrp">
				<div class="eos-dp-not-active-wrp"><input title="<?php printf( __( 'Activate/deactivate %s everywhere','eos-dp' ),esc_attr( $theme_name ) ); ?>" data-col="theme" class="eos-dp-global-chk-col" type="checkbox" /></div>
			</div>
		</div>
	</th>
	<?php
}

add_action( 'eos_dp_pre_table_head','eos_dp_pro_nonces' );
//It displays the auto settings button and related messages
function eos_dp_pro_nonces(){
	wp_nonce_field( 'eos_dp_pro_auto_settings', 'eos_dp_pro_auto_settings' );
	wp_nonce_field( 'eos_dp_plugins_contributions', 'eos_dp_plugins_contributions' );
	wp_nonce_field( 'eos_dp_pro_errors_check', 'eos_dp_pro_errors_check' );
	wp_nonce_field( 'eos_dp_pro_gt_metrix_test', 'eos_dp_pro_gt_metrix_test' );

}

add_action( 'eos_dp_action_buttons','eos_dp_home_autosuggest_action_buttons',10 );

//It adds premium action buttons
function eos_dp_home_autosuggest_action_buttons(){
	if( isset( $_GET['eos_dp_home'] ) ) : ?>
	<a href="#" class="eos-dp-pro-autosettings" title="<?php _e( 'Suggest plugins','eos-dp' ); ?>"><span class="dashicons dashicons-plugins-checked"></span></a>
	<?php endif;
}

add_filter( 'admin_body_class', 'eos_dp_admin_body_class' );
// Adds the class to the body tag in the dashboard according the options page.
function eos_dp_admin_body_class( $classes ) {
	if( isset( $_GET['page'] ) && eos_dp_is_fdp_page() ){
		$classes .= ' eos-dp-'.esc_attr( $_GET['page'] );
		if( isset( $_GET['eos_dp_home'] ) && 'true' === $_GET['eos_dp_home'] ){
			$classes .= ' eos-dp-homepage';
		}
	}
	return $classes;
}

if( isset( $_GET['eos_dp_preview'] ) && isset( $_GET['js'] ) && 'off' === $_GET['js'] ){
	add_action( 'admin_head','eos_dp_disable_javascript',10 );
}

add_action( 'admin_init','eos_dp_redirect_home_settings' );
function eos_dp_redirect_home_settings(){
	//Redirect to homepage settings
	if( isset( $_GET['eos_dp_home'] ) && 'true' === $_GET['eos_dp_home'] ){
		$show_on_front = eos_dp_get_option( 'show_on_front' );
		if( isset( $_GET['page'] ) && 'eos_dp_menu' === $_GET['page'] && 'posts' === $show_on_front ){
			wp_safe_redirect( admin_url( 'admin.php?page=eos_dp_by_archive&eos_dp_home=true' ) );
			exit;
		}
		if( isset( $_GET['page'] ) && 'eos_dp_by_archive' === $_GET['page'] && 'page' === $show_on_front ){
			if( absint( eos_dp_get_option( 'page_on_front' ) ) > 0 ){
				wp_safe_redirect( admin_url( 'admin.php?page=eos_dp_menu&eos_dp_home=true' ) );
				exit;
			}
		}
	}
}

add_filter( 'bulk_actions-edit-post','eos_dp_my_bulk_actions' );
add_filter( 'bulk_actions-edit-page','eos_dp_my_bulk_actions' );
add_filter( 'bulk_actions-edit-product','eos_dp_my_bulk_actions' );
 //Add bulk action to disable unused plugins on posts, pages, and products if any
function eos_dp_my_bulk_actions( $actions ) {
	$actions['eos_dp_disable_plugins'] = __( 'Set unused plugins','eos-dp' );
	return $actions;

}

add_action( 'handle_bulk_actions-edit-post', 'eos_dp_bulk_action_handler',10,3 );
add_action( 'handle_bulk_actions-edit-page', 'eos_dp_bulk_action_handler',10,3 );
add_action( 'handle_bulk_actions-edit-product', 'eos_dp_bulk_action_handler',10,3 );
//Handle bulk action to disable plugins on posts, pages, and products if any
function eos_dp_bulk_action_handler( $redirect,$action,$ids ) {
	if ( 'eos_dp_disable_plugins' === $action && !empty( $ids ) ){
		$post_type = get_post_type( $ids[0] );
		$redirect = add_query_arg(
			array(
				'eos_dp_post_type' => $post_type,
				'eos_dp_post_in' => implode( '-',$ids )
			),
			admin_url( 'admin.php?page=eos_dp_menu' )
		);
		wp_redirect( $redirect );
		exit;
	}
	return $redirect;
}

add_filter( 'eos_dp_user_can_metabox','eos_dp_pro_can_metabox' );
//Return if current user can see the FDP section in single post_status
function eos_dp_pro_can_metabox( $can ){
	$fdp_caps = eos_dp_user_capabilities();
	if( $fdp_caps && is_array( $fdp_caps ) && in_array( 'single_settings',array_keys( $fdp_caps ) ) && !$fdp_caps['single_settings'] ){
		return false;
	}
	return $can;
}

add_action( 'admin_menu','eos_dp_pro_admin_menu_filters' );
//Fire filters in admmin_menu actions
function eos_dp_pro_admin_menu_filters(){
	add_filter( 'eos_dp_user_can_settings','eos_dp_pro_can_settings' );
}

//Return if current user can see the FDP settings
function eos_dp_pro_can_settings( $can ){
	$fdp_caps = eos_dp_user_capabilities();
	if( $fdp_caps && is_array( $fdp_caps ) && in_array( 'global_settings',$fdp_caps ) && !$fdp_caps['global_settings'] ){
		return false;
	}
	return $can;
}

add_filter( 'all_plugins','eos_dp_plugins_in_list' );
//Remove plugins from plugins table in the page wp-admin/plugins.php according to the FDP Settings
function eos_dp_plugins_in_list( $plugins ){
	$fdp_caps = eos_dp_user_capabilities();
	if( $fdp_caps && is_array( $fdp_caps ) && in_array( 'see_plugin',$fdp_caps ) && !$fdp_caps['see_plugin'] ){
		if( in_array( EOS_DP_PLUGIN_BASE_NAME,array_keys( $plugins ) ) ){
			unset( $plugins[EOS_DP_PLUGIN_BASE_NAME] );
		}
		if( in_array( EOS_DP_PRO_PLUGIN_BASE_NAME,array_keys( $plugins ) ) ){
			unset( $plugins[EOS_DP_PRO_PLUGIN_BASE_NAME] );
		}
	}
	return $plugins;
}

add_action( 'admin_menu','eos_dp_remove_menu_items' );
//Remove menu items for the Plugins manager
function eos_dp_remove_menu_items(){
	$current_user = wp_get_current_user();
	if( in_array( 'fdp_plugins_manager',array_keys( $current_user->caps ) ) ){
		remove_menu_page( 'plugins.php' );
		remove_menu_page( 'options-general.php' );
		if( ( isset( $GLOBALS['pagenow'] ) && 'plugins.php' === $GLOBALS['pagenow'] ) || ( isset( $_GET['page'] ) && 'eos_dp_create_plugin' === $_GET['page'] ) ){
			wp_redirect( admin_url( 'admin.php?page=eos_dp_by_post_type' ) );
			exit;
		}
	}
}

if( isset( $_GET['fdp_add_favorites'] ) && 'true' ===  $_GET['fdp_add_favorites'] ){
	//Actions and filters to clean the page of plugins
	add_filter( 'admin_body_class','eos_dp_favorite_plugins_add_admin_body_class' );
	add_action( 'admin_menu','eos_dp_clean_plugins_page',99999999 );
	add_action( 'admin_head','eos_dp_favorite_plugins_inline' );
	add_action( 'admin_bar_menu','eos_dp_clean_top_bar',999999);
	add_action( 'install_plugins_pre_upload','eos_dp_favorite_plugins' );
}

//Add inline style in the page of plugins
function eos_dp_favorite_plugins(){
	wp_create_nonce( 'eos_dp_export_favorites_list','eos_dp_export_favorites_list' );
	?>
	<input type="hidden" id="fdp_favorites_list" name="fdp_favorites_list" />
	<?php
}
function eos_dp_favorite_plugins_inline(){
	wp_enqueue_script( 'fdp-favorite-plugins',EOS_DP_PLUGIN_URL.'/admin/js/fdp-favorites.js',array( 'jquery' ),EOS_DP_VERSION,true );
	$extra_style = '';
	$active_plugins = eos_dp_active_plugins();
	foreach( $active_plugins as $plugin ){
		$extra_style .= '.fdp-favorite-plugins .plugin-card-'.esc_attr( dirname( $plugin ) ).',';
	}
	$extra_style = rtrim( $extra_style,',' );
	if( '' !== $extra_style ){
		$extra_style .= '{opacity:0.3;pointer-events:none}';
	}
	?>
	<style id="fdp-favorite-plugins-css" type="text/css">
	.fdp-favorite-plugins .plugin-card,.fdp-favorite-plugins .plugin-card.fdp-added-to-favorites:hover{cursor:pointer;opacity:0.4}
	.fdp-favorite-plugins .plugin-card a{pointer-events:none;font-size:14px}
	.fdp-favorite-plugins .plugin-card:hover,.fdp-favorite-plugins .fdp-added-to-favorites{opacity:1}
	.fdp-favorite-plugins h1.wp-heading-inline,.fdp-favorite-plugins .filter-links,.fdp-favorite-plugins .tablenav,.fdp-favorite-plugins .desc p:not(.authors),.fdp-favorite-plugins .action-links,.fdp-favorite-plugins .plugin-card-bottom,.fdp-favorite-plugins #wpfooter,.fdp-favorite-plugins .upload-view-toggle,.fdp-favorite-plugins #contextual-help-link,.fdp-favorite-plugins #wpadminbar,.fdp-favorite-plugins #adminmenumain,.fdp-favorite-plugins #wpadminbar{display:none !important}
	.fdp-favorite-plugins .plugin-icon{position:absolute;display:block;width:64px;height:64px;margin: auto auto;left: 50%;margin-left:-32px;bottom:0}
	.fdp-favorite-plugins .plugin-card .name,.fdp-favorite-plugins .plugin-card .desc{margin-left:0;margin-right:0}
	.fdp-favorite-plugins .plugin-card{width:24%}
	.fdp-favorite-plugins .plugin-card-top{min-height:180px}
	.fdp-favorite-plugins .plugin-card{clear:none !important}
	.fdp-favorite-plugins p.authors, .fdp-favorite-plugins p.authors a{font-size:10px}
	.fdp-favorite-plugins .plugin-card h3{min-height:150px}
	.fdp-favorite-plugins form#plugin-filter{margin-top:16px}
	.fdp-favorite-plugins #wpcontent{margin-left: auto}
	.fdp-favorite-plugins .wp-filter{position:fixed;z-index:999999;margin-top:0}
	.fdp-favorite-plugins #the-list{margin-top:75px;text-align:center}
	<?php
	echo $extra_style;
}
// Add download link to admin top  bar
function eos_dp_clean_top_bar( $wp_admin_bar ){
	$all_toolbar_nodes = $wp_admin_bar->get_nodes();
  foreach ( $all_toolbar_nodes as $node ) {
    $wp_admin_bar->remove_node( $node->id );
  }
	return $wp_admin_bar;
}

//Clean page of plugins
function eos_dp_clean_plugins_page(){
	// global $menu,$submenu;
	// foreach( $menu as &$menu_item ){
	// 	$menu_item = array();
	// }
	remove_all_actions( 'admin_menu' );
	remove_all_actions( 'admin_notices' );
	remove_all_actions( 'admin_footer' );
}

//Add admin body class in the page of plugins
function eos_dp_favorite_plugins_add_admin_body_class( $classes ) {
	$classes .= ' fdp-favorite-plugins';
	return $classes;
}

//Return iframe to search plugins
function eos_dp_get_plugins_iframe(){
	return '<iframe style="width:100%;min-height:800px" src="'.admin_url( 'plugin-install.php?tab=search&type=term&fdp_add_favorites=true' ).'"></iframe>';
}
