<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
//It adds the section for creating a new plugin
function eos_dp_create_plugin_callback(){
	eos_dp_navigation();
  $extra_class = '';
	$user = wp_get_current_user();
	$site_name = get_bloginfo( 'name' );
	$plugin_name = sanitize_key( strtolower( str_replace( ' ','-',$site_name ) ) );
	wp_nonce_field( 'fdp_create_plugin','fdp_create_plugin' );
	?>
	<div id="fdp-create-plugin-wrp">
    <?php if( !is_writable( WP_PLUGIN_DIR ) ){
      $extra_class = ' eos-no-events';
      ?>
      <div class="notice notice-warning" style="padding:10px;font-size:20px"><?php _e( 'It looks you have no rights to write in the plugins folder. It will not be possible to create any plugin until the plugins folder is not writable.','eos-dp' ); ?></div>
    <?php } ?>
    <div>
      <h2><?php esc_html_e( 'Create custom plugin.','eos-dp-pro' ); ?></h2>
			<label for="fdp-create-plugin-name"><?php _e( 'Plugin name','eos-dp' ); ?></label>
			<p><input id="fdp-create-plugin-name" type="text" class="regular-text" placeholder="<?php echo esc_attr( ucwords( $site_name ) ); ?>" /></p>
			<label for="fdp-create-plugin-author"><?php _e( 'Plugin author','eos-dp' ); ?></label>
			<p><input id="fdp-create-plugin-author" type="text" class="regular-text" placeholder="<?php echo esc_attr( ucfirst( $user->user_login ) ); ?>" /></p>
			<label for="fdp-create-plugin-author_uri"><?php _e( 'Author URI','eos-dp' ); ?></label>
			<p><input id="fdp-create-plugin-author_uri" type="url" class="regular-text" placeholder="<?php echo esc_url( $user->user_url ); ?>" /></p>
			<label for="fdp-create-plugin-description"><?php _e( 'Plugin description','eos-dp' ); ?></label>
			<p><input id="fdp-create-plugin-description" type="text" style="width:100%;max-width:600px" placeholder="<?php printf( 'Custom code for %s.',esc_attr( $site_name ) ); ?>" /></p>
      <p style="margin-top:32px"><span id="fdp-create-plugin" class="button<?php echo $extra_class; ?>"><span class="dashicons dashicons-admin-plugins" style="margin:4px 0"></span><?php _e( 'Create plugin','eos-dp' ); ?></span></p>
			<p><?php _e( 'Pushing the button FDP will create an empty new plugin for your custom code.','eos-dp' ); ?></p>
			<p><?php _e( 'You will need to activate the new plugin as you do for other plugins.','eos-dp' ); ?></p>
    </div>
		<div id="fdp-success" class="notice notice-success eos-dp-opts-msg_success eos-hidden" style="padding:10px"><?php _e( 'Plugin created successfully!','eos-dp' ); ?>
			<div class="eos-dp-margin-top-15">
				<a id="fdp-edit-new-plugin" class="button" href="#" target="_blank">'<?php _e( 'Start coding.','eos-dp' ); ?></a>
				<a id="fdp-activate-new-plugin" class="button" href="#"><?php _e( 'Activate your new plugin.','eos-dp' ); ?></a>
			</div>
		</div>
		<div id="fdp-fail" class="notice notice-error eos-hidden" style="padding:10px" data-default_msg="<?php esc_attr_e( 'Something went wrong!','eos-dp-pro' ); ?>"></div>
	</div>
	<?php
}
