<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
//Callback for deactivate by archive settings page
function eos_dp_help_callback(){
	if( !current_user_can( 'activate_plugins' ) ){
	?>
		<h2><?php _e( 'Sorry, you have not the right for this page','eos-dp' ); ?></h2>
		<?php
		return;
	}
	eos_dp_alert_plain_permalink();
	eos_dp_navigation();
	$dir = is_rtl() ? 'left' : 'right';
	$tab = isset( $_GET['tab'] ) ? str_replace( '-','_',$_GET['tab'] ) : 'common_issues';
	?>
	<div>
		<input style="min-width:25rem" type="text" id="eos-dp-search-on-support-input" placeholder="<?php _e( 'Search on the support forum','eos-dp' ); ?>" />
		<a class="button"style="margin:0 8px" id="eos-dp-search-on-support-button" href="https://wordpress.org/search/freesoul+deactivate+plugins" target="_blank" rel="noopener"><?php _e( 'Search','eos-dp' ); ?></a>
	</div>
	<?php
	if( function_exists( 'eos_dp_help_'.sanitize_key( $tab ).'_section' ) ){
		call_user_func( 'eos_dp_help_'.sanitize_key( $tab ).'_section' );
	}
	?>

	<script>
	var support_button = document.getElementById('eos-dp-search-on-support-button'),
		support_input = document.getElementById('eos-dp-search-on-support-input');
	support_button.addEventListener('click',function(){
		support_button.href = 'https://wordpress.org/search/freesoul+deactivate+plugins+' + support_input.value.replace(' ','+').split('?')[0] + '?forum=1';
	});
	</script>
	<?php
}

//SOS section
function eos_dp_help_common_issues_section(){
	$post_types = '<a target="_blank" href="'.admin_url( 'admin.php?page=eos_dp_by_post_type' ).'">Post Types Settings</a>';
	$singles = '<a target="_blank" href="'.admin_url( 'admin.php?page=eos_dp_menu' ).'">Singles Settings</a>';
	$custom_urls = '<a target="_blank" href="'.admin_url( 'admin.php?page=eos_dp_url' ).'">Custom URLs Settings</a>';
	$support_forum = '<a target="_blank" href="https://wordpress.org/support/plugin/freesoul-deactivate-plugins/">Support Forum</a>';
	$repository_tags = 'https://plugins.svn.wordpress.org/freesoul-deactivate-plugins/tags/';
	$response = wp_remote_get( $repository_tags );
	$download_url = 'https://downloads.wordpress.org/plugin/freesoul-deactivate-plugins.';
	$filezilla = '<a href="https://wordpress.org/support/article/using-filezilla/" target="_bank" rel="noopener">FileZilla</a>';
	$versions_list = false;
	if( !is_wp_error( $response ) ){
		$body = wp_remote_retrieve_body( $response );
		if( class_exists( 'DOMDocument' ) ){
			libxml_use_internal_errors( true );
			$dom = new DOMDocument();
			$dom->loadHTML( $body );
			$ul = $dom->getElementsByTagName( 'ul' );
			if( $ul ){
				$ul = $ul->item( 0 );
				$links = $ul->getElementsByTagName ( 'a' );
				if( $links ){
					$versions_list = array();
					$versions_list[] = '</select>';
					foreach( $links as $link ){
						$version = str_replace( '/','',$link->nodeValue );
						if( version_compare( $version,EOS_DP_VERSION ) < 0 && version_compare( $version,'1.7.0' ) > 0 && substr_count( $version,'.' ) < 3 ){
							if( EOS_DP_VERSION !== $version && absint( $version ) > 0 ){
								$versions_list[] = '<option><a href="'.esc_url( $download_url.esc_attr( $version ).'.zip' ).'">'.esc_html( $version ).'</a></option>';
							}
						}
					}
					$versions_list[] = '<select id="eos-dp-previuos-versions" style="margin-top:-4px">';
					$versions_list = implode( '',array_reverse( $versions_list ) );
				}
			}
		}
	}
	$versions_download = $versions_list.' <a href="#" id="eos-dp-download-previous" class="button" download onclick="this.href=\''.$download_url.'\' + document.getElementById(\'eos-dp-previuos-versions\').value + \'.zip\';">'.__( 'Download','eos-dp' ).'</a>';
?>
	<section class="eos-dp-section">
		<h2><?php _e( 'Common issues','eos-dp' ); ?></h2>
		<table id="eos-dp-help-table" class="wp-list-table widefat fixed striped table-view-list">
			<thead>
				<tr>
					<td><?php _e( 'Issue','eos-dp' ); ?></td>
					<td><?php _e( 'Tip','eos-dp' ); ?></td>
				</tr>
			</thead>
			<tbody>
				<tr>
					<td>On a certain page it doesn't disable the right plugins.</td>
					<td>
						<p>Be sure that the <?php echo $post_types; ?> are not overriding the <?php echo $singles; ?></p>
						<p>If in the <?php echo $post_types; ?> you have the full circle <span class="eos-dp-priority-legend-wrp eos-dp-priority-active"></span> for that post type, check that in the Singles settings that post has the closed padlock <span class="eos-post-locked-icon"></span>.</p>
						<p>On every single page you have also a section to disable the plugins. Be sure you, or someone else don't save the page with the wrong options.</p>
						<p>Be sure that the <?php echo $custom_urls; ?> are not overriding the other options.</p>
						<p>Remember that in the Singles and Archives settings, you can check which plugins are really disabled clicking on the help icon <span class="dashicons dashicons-editor-help" style="display:inline-block;margin-top:-5px;color:#D3C4B8;font-size:30px"></span>.</p>
					</td>
				</tr>
				<tr>
					<td>On mobile it doesn't disable the right plugins.</td>
					<td>
						<p>Be sure that you have a full page cache that distinguishes between mobile and desktop devices.</p>

					</td>
				</tr>
				<tr>
					<td>I don't see all the post types.</td>
					<td>
						<p>Try deactivating and reactivating Freesoul Deactivate Plugins (without delete it).</p>

					</td>
				</tr>
				<tr>
					<td>I don't see a certain page in the <?php echo $singles; ?>.</td>
					<td>
						<p>Probably the URL of that page is created by a plugin. In this case, use the <?php echo $custom_urls; ?>.</p>
					</td>
				</tr>
				<tr>
					<td>The new version doesn't work on my site.</td>
					<td>
						<p>If it's urgent, go back to the previus version.</p>
						<p>Download a previous version that was working and replace the actual version using FTP. Then <strong>deactivate and reactivate the plugin.</strong></p>
						<p>If you have never used FTP read how to install and use <?php echo $filezilla; ?> to transfer files via FTP.</p>
						<p>You will find <a rel="noopener" target="_blank" href="https://wordpress.org/plugins/freesoul-deactivate-plugins/advanced/#plugin-download-history-stats">here</a> the previous versions of Freesoul Deactivate Plugins.</p>
						<?php if( $versions_list ){ ?>
						<p>Or directly clicking on the button after selecting the right version <?php echo $versions_download; ?></p>
						<?php } ?>
						<p>In any case, please open a thread on the <?php echo $support_forum; ?>, so we can be aware of the issue and do our investigations to solve it.</p>
					</td>
				</tr>
			</tbody>
		</table>
	</section>
	<?php
}
//Flowchart section
function eos_dp_help_flowchart_section(){
	?>
	<section class="eos-dp-section">
		<div id="eos-dp-flow-chart">
			<h2><?php _e( 'How Freesoul Deactivate Plugins disables plugins according to your settings.','eos-dp' ); ?></h2>
			<img width="1221" height="1069" usemap="#eos_dp_flow_map" src="<?php echo EOS_DP_PLUGIN_URL.'/img/flow-chart.png'; ?>" />
			<map id="eos_dp_flow_map" name="eos_dp_flow_map">
				<area target="_blank" alt="<?php esc_attr_e( 'Mobile Settings','eos-dp' ); ?>" title="<?php esc_attr_e( 'Mobile Settings','eos-dp' ); ?>" href="<?php echo admin_url( 'admin.php?page=eos_dp_mobile','eos-dp' ); ?>" coords="140,640,299,696" shape="rect">
				<area target="_blank" alt="<?php esc_attr_e( 'Search Settings','eos-dp' ); ?>" title="<?php esc_attr_e( 'Search Settings','eos-dp' ); ?>" href="<?php echo admin_url( 'admin.php?page=eos_dp_search','eos-dp' ); ?>" coords="294,1067,147,1010" shape="rect">
				<area target="_blank" alt="<?php esc_attr_e( 'Archives Settings','eos-dp' ); ?>" title="<?php esc_attr_e( 'Archives Settings','eos-dp' ); ?>" href="<?php echo admin_url( 'admin.php?page=eos_dp_by_archive','eos-dp' ); ?>" coords="794,285,634,225" shape="rect">
				<area target="_blank" alt="<?php esc_attr_e( 'Terms Archives Settings','eos-dp' ); ?>" title="<?php esc_attr_e( 'Terms Archives Settings','eos-dp' ); ?>" href="<?php echo admin_url( 'admin.php?page=eos_dp_by_term_archive','eos-dp' ); ?>" coords="981,225,1141,282" shape="rect">
				<area target="_blank" alt="<?php esc_attr_e( 'Singles Settings','eos-dp' ); ?>" title="<?php esc_attr_e( 'Singles Settings','eos-dp' ); ?>" href="<?php echo admin_url( 'admin.php?page=eos_dp_menu','eos-dp' ); ?>" coords="719,534,880,597" shape="rect">
				<area target="_blank" alt="<?php esc_attr_e( 'Post Types Settings','eos-dp' ); ?>" title="<?php esc_attr_e( 'Post Types Settings','eos-dp' ); ?>" href="<?php echo admin_url( 'admin.php?page=eos_dp_by_post_type','eos-dp' ); ?>" coords="702,801,866,861" shape="rect">
				<area target="_blank" alt="<?php esc_attr_e( 'Custom URLs Settings','eos-dp' ); ?>" title="<?php esc_attr_e( 'Custom URLs Settings','eos-dp' ); ?>" href="<?php echo admin_url( 'admin.php?page=eos_dp_url','eos-dp' ); ?>" coords="578,1066,417,1009" shape="rect">
			</map>
		</div>
	</section>
	<?php
}
