<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

//Callback for deactivate in integration
function eos_dp_integration_callback(){
	if( !current_user_can( 'activate_plugins' ) && function_exists( 'eos_dp_active_plugins' ) ){
	?>
		<h2><?php _e( 'Sorry, you have not the right for this page','eos-dp' ); ?></h2>
		<?php
		return;
	}
	$plugins_integration = eos_dp_plugins_integration();
	if( !isset( $_GET['int_plugin'] ) ){
		$int_plugin = 'wordpress-core';
	}
	else{
		$int_plugin = $_GET['int_plugin'];
	}
	$plugin_info = $plugins_integration[$int_plugin];
	if( !isset( $plugins_integration[$int_plugin] ) ){
		printf( __( 'No integration available for %s','eos-dp' ),strtoupper( str_replace( '-',' ',esc_html( $int_plugin ) ) ) );
		return;
	}
	$is_active = $plugin_info['is_active'];
	if( !$is_active ){
		printf( __( '%s is not active','eos-dp' ),strtoupper( str_replace( '-',' ',esc_html( $int_plugin ) ) ) );
		return;
	}
	$active_plugins = eos_dp_active_plugins();
	$plugins_actions = eos_dp_get_option( 'eos_dp_integration_actions' );
	$integration_actions_theme = eos_dp_get_option( 'eos_dp_integretion_actions_theme' );
	$n = count( $active_plugins );
	wp_nonce_field( 'eos_dp_integration_actions_setts','eos_dp_integration_actions_setts' );
	eos_dp_navigation();
	?>
	<section id="eos-dp-by-integration-section" class="eos-dp-section">
		<div class="eos-dp-margin-top-32">
			<h2><?php printf( esc_html__( 'Uncheck the plugins you want to deactivate on specific actions fired by %s.','eos-dp' ),strtoupper( str_replace( '-',' ',esc_html( $int_plugin ) ) ) ); ?></h2>
			<?php do_action( 'eos_dp_before_wrapper' ); ?>
			<div id="eos-dp-wrp">
				<div>
					<input id="eos-dp-ajax-desc" type="radio" value="description" name="eos-dp-ajax-display" checked />
					<label style="display:inline-block" for="eos-dp-ajax-desc"><?php esc_html_e( 'Show action descriptions','eos-dp' ); ?></label>
					<span>&nbsp;&nbsp;</span><input id="eos-dp-ajax-slug" type="radio" value="slug" name="eos-dp-ajax-display" />
					<label style="display:inline-block" for="eos-dp-ajax-value"><?php esc_html_e( 'Show action slugs','eos-dp' ); ?></label>
				</div>
				<?php
				$row = 1;
				?>
				<?php eos_dp_plugin_names_orientation_ctrl(); ?>
				<table id="eos-dp-setts"  data-zoom="1">
				<?php eos_dp_table_head();
				$plugins_by_dirs = isset( $GLOBALS['eos_dp_plugins_by_dirs'] ) ? $GLOBALS['eos_dp_plugins_by_dirs'] : eos_dp_get_plugins();
				?>
					<?php
					foreach( $plugin_info['ajax_actions'] as $action => $arr ){
						$description = isset( $arr['description'] ) ? $arr['description'] : '';
						$custom_default = isset( $arr['default'] ) && 'disabled' === $arr['default'] ? $active_plugins : array();
						$values = isset( $plugins_actions[$action] ) ? explode( ',',$plugins_actions[$action] ) : $custom_default;
						?>
						<tr class="eos-dp-integration-row eos-dp-post-row" data-integration="<?php echo esc_attr( $action ); ?>">
							<td class="eos-dp-post-name-wrp">
								<span class="eos-dp-not-active-wrp"><input title="<?php printf( __( 'Activate/deactivate all plugins for %s','eos-dp' ),esc_attr( $description ) ); ?>" data-row="<?php echo esc_attr( $row ); ?>" class="eos-dp-global-chk-row" type="checkbox" /></span>
								<span class="eos-dp-ajax-desc"><?php echo esc_html( $description ); ?></span>
								<span class="eos-dp-ajax-slug eos-hidden"><?php echo esc_html( $action ); ?></span>
								<?php
								if( isset( $arr['notes'] ) && '' !== $arr['notes'] ){
								?>
								<span class="dashicons dashicons-info-outline" title="<?php echo esc_attr( $arr['notes'] ); ?>"></span>
								<?php
								}
								?>
								<div class="eos-dp-actions">
									<a title="<?php _e( 'Copy this row settings','eos-dp' ); ?>" class="eos-dp-copy" href="#"><span class="dashicons dashicons-admin-page"></span></a>
									<a title="<?php _e( 'Paste last copied row settings','eos-dp' ); ?>" class="eos-dp-paste" href="#"><span class="dashicons dashicons-category"></span></a>
								</div>
							</td>
							<?php
							for( $k = 0;$k < $n;++$k ){
								if( in_array( $active_plugins[$k],array_keys( $plugins_by_dirs ) ) ){
									$extra_class = isset( $active_plugins[$k] ) && $active_plugins[$k] === EOS_DP_PLUGIN_BASE_NAME ? ' eos-hidden' : '';
									?>
									<td<?php echo dirname( $active_plugins[$k] ) === $int_plugin ? ' style="display:none"' : ''; ?> class="center<?php echo !in_array( $active_plugins[$k],$values ) ? ' eos-dp-active' : '';echo $extra_class; ?>">
										<div class="eos-dp-td-chk-wrp eos-dp-td-integration-chk-wrp">
											<input class="eos-dp-row-<?php echo $row; ?> eos-dp-col-<?php echo $k + 1; ?> eos-dp-col-<?php echo ( $k + 1 ).'-'.esc_attr( $action ); ?>" data-checked="<?php echo in_array( $active_plugins[$k],$values ) ? 'checked' : 'not-checked'; ?>" type="checkbox"<?php echo in_array( $active_plugins[$k],$values ) ? ' checked' : ''; ?> />
										</div>
									</td>
									<?php
								}
							}
							?>
							<td class="center<?php echo !isset( $integration_actions_theme[$action] ) || $integration_actions_theme[$action] ? ' eos-dp-active' : ''; ?>">
								<div class="eos-dp-td-chk-wrp eos-dp-td-integration-chk-wrp">
									<input class="eos-dp-row-theme eos-dp-col-<?php echo $k + 1; ?> eos-dp-col-<?php echo ( $k + 1 ).'-'.esc_attr( $action ); ?>" data-checked="checked" type="checkbox" checked />
								</div>
							</td>
						</tr>
						<?php
					}
				?>
				</table>
			</div>
		</div>
		<?php eos_dp_save_button(); ?>
	</section>
	<?php
}
