<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
//Callback function for the plugin settings page
function eos_dp_options_page_callback(){
	if( !current_user_can( 'activate_plugins' ) ){
	?>
		<h2><?php _e( 'Sorry, you have not the right for this page','eos-dp' ); ?></h2>
		<?php
		return;
	}
	if( function_exists( 'pll_default_language' ) ){
		$default_language = pll_default_language();
	}
	elseif( function_exists( 'wpml_default_language' ) ){
		$default_language = wpml_default_language();
	}
	else{
		$default_language = get_bloginfo( 'language' );
	}
	wp_nonce_field( 'eos_dp_setts', 'eos_dp_setts' );
	wp_nonce_field( 'eos_dp_key', 'eos_dp_key' );
	$paths = array();
	$active_plugins = eos_dp_active_plugins();
	$plugins_table = eos_dp_plugins_table();
	$posts_per_page = isset( $_GET['posts_per_page'] ) && absint( $_GET['posts_per_page'] ) > 0 ? esc_attr( $_GET['posts_per_page'] ) : 30;
	$post_type = isset( $_GET['eos_dp_post_type'] ) ? esc_attr( $_GET['eos_dp_post_type'] ) : 'page';
	$labsObj = get_post_type_object( $post_type );
	if( isset( $labsObj->labels ) ){
		$labs = $labsObj->labels;
		$active_label = isset( $labs->name ) ? $labs->name : __( 'posts','eos-dp' );
	}
	$plugins_by_dirs = eos_dp_get_plugins();
	$eos_dp_need_custom_url = eos_dp_get_option( 'eos_dp_need_custom_url' );
	$post_types_matrix = eos_dp_get_option( 'eos_post_types_plugins' );
	$post_types_matrix_pt = isset( $post_types_matrix[$post_type] ) ? $post_types_matrix[$post_type] : array();
	$post_types_plugins_pt = $plugins_table[$post_type];
	global $overridable;
	$overridable = $post_types_plugins_pt[0];
	$posts_per_page = isset( $_GET['posts_per_page'] ) ? absint( $_GET['posts_per_page'] ) : '30';
	$current_labels_name = '';
	$need_custom_url = array();
	$status_icons = array(
		'public' => '',
		'private' => '<span title="'.__( 'Private','eos-dp' ).'" class="dashicons dashicons-privacy"></span>',
		'draft' => '<span title="'.__( 'Draft','eos-dp' ).'" class="dashicons dashicons-hidden"></span>'
	);
	if( '1' == $overridable && !isset( $_GET['eos_dp_home'] ) || 'true' !== $_GET['eos_dp_home'] ){
		?>
		<div class="eos-dp-warning notice notice-warning is-dismissible">
			<h2><?php
				printf(
					__( 'The %s are overriding these settings for all the rows that don\'t have the closed padlock %s.','eos-dp' ),
					'<a style="text-decoration:none;color:#D3C4B8" href="'.admin_url( 'admin.php?page=eos_dp_by_post_type' ).'">'.__( 'Post Type Settings','eos-dp' ).'</a>',
					'<span class="eos-post-locked-icon"></span>'
				);

			?></h2>
		</div>
		<?php
	}
	$ofs = isset( $_GET['eos_page'] ) && absint( $_GET['eos_page'] ) > 0 ? ( absint( $_GET['eos_page'] ) - 1 ) * $posts_per_page : 0;
	$args = array( 'post_type' => $post_type,'post_status' => 'any','posts_per_page' => $posts_per_page,'offset' => $ofs );
	$args['orderby'] = isset( $_GET['orderby'] ) ? esc_attr( $_GET['orderby'] ) : 'title';
	$args['order'] = isset( $_GET['order'] ) ? esc_attr( $_GET['order'] ) : 'ASC';
	if( isset( $_GET['eos_dp_post_in'] ) && ''  !== $_GET['eos_dp_post_in'] ){
		$args['post__in'] = explode( '-',esc_attr( $_GET['eos_dp_post_in'] ) );
	}
	if( isset( $_GET['eos_post_title'] ) ){
		?><h2><?php printf( __( 'Results for %s','eos-dp' ),esc_html( $_GET['eos_post_title'] ) ); ?></h2><?php
		$args['s'] = esc_attr( urldecode( $_GET['eos_post_title'] ) );
	}
	if( isset( $_GET['eos_cat'] ) ){
		$cat = get_term( (int) $_GET['eos_cat'] );
		$cat = $cat && !is_wp_error( $cat ) ? sprintf( __( 'the category "%s"','eos-dp' ),$cat->name ) : sprintf( __( 'Category id %s','eos-dp' ),(int) $_GET['eos_cat'] );
		?><h2><?php printf( __( 'Results for %s','eos-dp' ),$cat ); ?></h2><?php
		$args['category'] = sanitize_title( $_GET['eos_cat'] );
	}
	if( in_array( $post_type,array( 'post','page' ) ) ){
		if( function_exists( 'eos_scfm_get_mobile_ids' ) ){
			if( isset( $_GET['device'] ) && 'mobile' === $_GET['device'] ){
				$args['post__in'] = eos_scfm_get_mobile_ids();
			}
			elseif( isset( $_GET['device'] ) && 'desktop' === $_GET['device'] ){
				$args['post__not_in'] = eos_scfm_get_mobile_ids();
			}
		}
	}
	$is_home = false;
	$is_relevant_pages = false;
	$important_pages = eos_dp_important_pages();
	if( isset( $_GET['eos_dp_home'] ) && 'true' === $_GET['eos_dp_home'] ){
		$show_on_front = eos_dp_get_option( 'show_on_front' );
		if( 'page' === $show_on_front ){
			$is_home = true;
		}
	}
	elseif( isset( $_GET['eos_dp_relevant_pages'] ) && 'true' === $_GET['eos_dp_relevant_pages'] ){
		$is_relevant_pages = true;
		$args['post__in'] = $important_pages['ids'];
	}
	$page_on_front = eos_dp_get_option( 'page_on_front' );
	$page_for_posts = eos_dp_get_option( 'page_for_posts' );
	if( 0 === absint( $page_on_front ) && absint( $page_for_posts ) > 0 ){
		$page_on_front = absint( $page_for_posts );
	}
	$posts = !$is_home ? get_posts( $args ) : array( get_post( $page_on_front ) );
	$ids = array();
	foreach( $posts as $post ){
		$ids[] = $post->ID;
	}
	$meta_valuesObj = eos_dp_get_multiple_metadata( '_eos_deactive_plugins_key',$ids );
	$meta_values = array();
	foreach( $meta_valuesObj as $obj ){
		$meta_values[sanitize_key( $obj->post_id )] = sanitize_text_field( $obj->meta_value );
	}
	eos_dp_alert_plain_permalink();
	eos_dp_navigation();
	$pageSpeedInsightsUrl = 'https://developers.google.com/speed/pagespeed/insights/';
	$fdp_is_single_post = 1 === count( $posts ) || ( isset( $_GET['eos_dp_post_in'] ) && absint( $_GET['eos_dp_post_in'] ) > 0 && isset( $_GET['single_post'] ) && 1 === absint( $_GET['single_post'] ) );
	if( $fdp_is_single_post && !isset( $_GET['eos_dp_post_in'] ) ){
		$single_post = $posts[0];
		$single_post_id = $single_post->ID;
	}
	else{
		$single_post_id = isset( $_GET['eos_dp_post_in'] ) ? absint( $_GET['eos_dp_post_in'] ) : false;
	}
	?><script> var is_single_post = <?php echo $fdp_is_single_post ? 'true' : 'false'; ?>;</script><?php
	if( !$is_home && !$is_relevant_pages ):
	$count_posts = wp_count_posts( $post_type );
	$published_posts = $count_posts->publish;
	$pagesN = ceil( $published_posts/max( 1,$posts_per_page ) );
	$current_page = isset( $_GET['eos_page'] ) ? $_GET['eos_page'] : 1;
	?>
	<div id="eos-dp-order-wrp" style="display:inline-block">
		<div class="eos-dp-display-data" style="display:inline-block;float:<?php echo is_rtl() ? 'right' : 'left'; ?>">
			<h4 style="margin-bottom:0"><?php _e( 'Number of posts','eos-dp' ); ?></h4>
			<input id="eos-dp-posts-per-page" type="number" min="10" max="200" value="<?php echo $posts_per_page; ?>" />
		</div>
		<div class="eos-dp-display-data" style="display:inline-block">
			<h4 style="margin-bottom:0"><?php _e( 'Order by','eos-dp' ); ?></h4>
			<select id="eos-dp-orderby-sel">
				<option value="title"<?php echo isset( $_GET['orderby'] ) && $_GET['orderby'] === 'title' ? ' selected' : ''; ?>><?php _e( 'Title','eos-dp' ); ?></option>
				<option value="ID"<?php echo isset( $_GET['orderby'] ) && $_GET['orderby'] === 'ID' ? ' selected' : ''; ?>><?php _e( 'Post id','eos-dp' ); ?></option>
				<option value="author"<?php echo isset( $_GET['orderby'] ) && $_GET['orderby'] === 'author' ? ' selected' : ''; ?>><?php _e( 'Author','eos-dp' ); ?></option>
				<option value="date"<?php echo isset( $_GET['orderby'] ) && $_GET['orderby'] === 'date' ? ' selected' : ''; ?>><?php _e( 'Date','eos-dp' ); ?></option>
				<option value="modified"<?php echo isset( $_GET['orderby'] ) && $_GET['orderby'] === 'modified' ? ' selected' : ''; ?>><?php _e( 'Last modified date','eos-dp' ); ?></option>
			</select>
		</div>
		<div class="eos-dp-display-data" style="display:inline-block">
			<h4 style="margin-bottom:0"><?php _e( 'Order','eos-dp' ); ?></h4>
			<select id="eos-dp-order-sel">
				<option value="ASC"<?php echo isset( $_GET['order'] ) && strtolower( $_GET['order'] ) === 'asc' ? ' selected' : ''; ?>><?php _e( 'Ascending','eos-dp' ); ?></option>
				<option value="DESC"<?php echo isset( $_GET['order'] ) && strtolower( $_GET['order'] ) === 'desc' ? ' selected' : ''; ?>><?php _e( 'Descending','eos-dp' ); ?></option>
			</select>
		</div>
		<?php
		if( function_exists( 'eos_scfm_get_mobile_ids' ) && in_array( $post_type,array( 'post','page' ) ) ){
		?>
		<div class="eos-dp-display-data" style="display:inline-block">
			<h4 style="margin-bottom:0"><?php _e( 'Device','eos-dp' ); ?></h4>
			<select id="eos-dp-device">
				<option value="all"<?php echo isset( $_GET['device'] ) && strtolower( $_GET['device'] ) === 'all' ? ' selected' : ''; ?>><?php _e( 'All devices','eos-dp' ); ?></option>
				<option value="desktop"<?php echo isset( $_GET['device'] ) && strtolower( $_GET['device'] ) === 'desktop' ? ' selected' : ''; ?>><?php _e( 'Desktop devices','eos-dp' ); ?></option>
				<option value="mobile"<?php echo isset( $_GET['device'] ) && strtolower( $_GET['device'] ) === 'mobile' ? ' selected' : ''; ?>><?php _e( 'Mobile devices','eos-dp' ); ?></option>
			</select>
		</div>
		<?php
		}
		?>
		<div class="eos-dp-display-data" style="display:inline-block;line-height:2;margin:0 6px">
			<a href="<?php echo add_query_arg( array( 'posts_per_page' => 30,'orderby'=>'title','order'=>'ASC' ),admin_url( 'admin.php?page=eos_dp_menu&eos_dp_post_type='.$post_type ) ); ?>" class="button" id="eos-dp-order-refresh"><?php _e( 'Apply','eos-dp' ); ?></a>
		</div>
	</div>
	<?php if( $pagesN > 1 ): ?>
	<div id="eos-dp-posts-nav" style="margin:0 20px;float:<?php echo is_rtl() ? 'left' : 'right'; ?>">
		<div class="tablenav-pages"><span class="displaying-num"><?php printf( __( '%s items','eos-dp' ),$published_posts ); ?></span>
			<span class="pagination-links">
				<a class="button next-page<?php echo $current_page -1 === 0 ? ' eos-no-events' : ''; ?>" href="<?php echo add_query_arg( array( 'posts_per_page' => $posts_per_page,'eos_dp_post_type' => $post_type,'eos_page' => 1 ),admin_url( 'admin.php?page=eos_dp_menu' ) ); ?>"><span class="screen-reader-text">First page</span><span aria-hidden="true">&#xab;</span></a>
				<a class="button next-page<?php echo $current_page < 2 ? ' eos-no-events' : ''; ?>" href="<?php echo add_query_arg( array( 'posts_per_page' => $posts_per_page,'eos_dp_post_type' => $post_type,'eos_page' => $current_page - 1 ),admin_url( 'admin.php?page=eos_dp_menu' ) ); ?>"><span class="screen-reader-text">Previous page</span><span aria-hidden="true">&#x2039;</span></a>
				<span class="paging-input">
					<label for="current-page-selector" class="screen-reader-text"><?php _e( 'Current Page','eos-dp' ); ?></label>
					<input data-url="<?php echo add_query_arg( 'eos_dp_post_type',$post_type,admin_url( 'admin.php?page=eos_dp_menu' ) ); ?>" class="current-page" id="current-page-selector" type="number" min="1" max="<?php echo $pagesN; ?>" step="1" name="paged" value="<?php echo esc_attr( $current_page ); ?>" size="1" aria-describedby="table-paging">
					<span class="tablenav-paging-text"> of <span class="total-pages"><?php echo $pagesN ; ?></span>
				</span>
			</span>
			<a class="button next-page<?php echo $current_page - $pagesN == 0 ? ' eos-no-events' : ''; ?>" href="<?php echo add_query_arg( array( 'posts_per_page' => $posts_per_page,'eos_dp_post_type' => $post_type,'eos_page' => $current_page + 1 ),admin_url( 'admin.php?page=eos_dp_menu' ) ); ?>"><span class="screen-reader-text">Next page</span><span aria-hidden="true">&#8250;</span></a>
			<a class="button last-page<?php echo $current_page - $pagesN == 0 ? ' eos-no-events' : ''; ?>" href="<?php echo add_query_arg( array( 'posts_per_page' => $posts_per_page,'eos_dp_post_type' => $post_type,'eos_page' => $pagesN ),admin_url( 'admin.php?page=eos_dp_menu' ) ); ?>"><span class="screen-reader-text">Last page</span><span aria-hidden="true">&#187;</span></a></span>
		</div>
		<div class="eos-dp-display-data eos-dp-toggle-search-wrp" style="display:inline-block;line-height:2;margin:16px 0">
			<span><?php _e( 'Search Post','eos-dp' ); ?></span>
			<span id="eos-dp-toggle-search" class="hover dashicons dashicons-search" style="line-height:32px"></span>
		</div>
		<div class="eos-dp-search-wrp eos-hidden">
			<div class="eos-dp-search-box" style="margin:32px 20px">
				<label class="screen-reader-text" for="post-search-input"><?php _e( 'Search By Title','eos-dp' ); ?></label>
				<input type="search" id="eos-dp-post-search" value="">
				<input type="submit" id="eos-dp-post-search-submit" data-url="<?php echo add_query_arg( 'eos_post_title','',admin_url( 'admin.php?page=eos_dp_menu&eos_dp_post_type='.$post_type ) ); ?>" class="button" value="<?php _e( 'Search By Title','eos-dp' ); ?>" />
			</div>
			<div class="eos-dp-search-box" style="margin:32px 20px">
				<label class="screen-reader-text" for="post-search-input"><?php _e( 'Search By Category','eos-dp' ); ?></label>
				<div id="eos-dp-by-cat-search" style="display:inline-block"><?php wp_dropdown_categories(); ?></div>
				<input type="submit" id="eos-dp-by-cat-search-submit" data-url="<?php echo add_query_arg( 'eos_cat','',admin_url( 'admin.php?page=eos_dp_menu&eos_dp_post_type='.$post_type ) ); ?>" class="button" value="<?php _e( 'Search By Category','eos-dp' ); ?>" />
			</div>
		</div>
	</div>
	<?php endif; ?>
	<?php
	endif;
	if( count( $posts ) < 1 ){
		?>
		<p><?php printf( __( 'You have no %s','eos-dp' ),$active_label ); ?></p>
		<?php
		return;
	}
	$title = isset( $_GET['eos_dp_relevant_pages'] ) && 'true' === $_GET['eos_dp_relevant_pages'] ? __( 'Relevant pages','eos-dp' ) : $active_label;
	$title = isset( $_GET['eos_dp_home'] ) && 'true' === $_GET['eos_dp_home'] ? __( 'Homepage','eos-dp' ) : $title;
	if( $fdp_is_single_post ){
		add_filter( 'admin_footer_text','__return_false',999999 );
		add_filter( 'update_footer','__return_false',999999 );
		remove_all_actions( 'admin_footer' );
	}
	?>

	<section id="eos-dp-control-panel-section" class="eos-dp-section<?php echo '1' == $overridable ? ' eos-single-overrided' : '';echo $fdp_is_single_post ? ' eos-dp-one-post' : ''; ?>">
		<h2 id="eos-dp-singles-title" style="display:inline-block" data-post-type="<?php echo $post_type; ?>"><?php echo esc_html( $title ); ?></h2>
		<div id="fdp-singles-filter" style="display:inline-block;float:<?php echo is_rtl() ? 'left' : 'right'; ?>">
			<span title="<?php _e( 'All','eos-dp' ); ?>" class="hover fdp-filter-all" style="font-size:16px;text-transform:uppercase"><?php _e( 'All','eos-dp' ); ?></span>
			<span title="<?php _e( 'Locked','eos-dp' ); ?>" class="hover dashicons dashicons-lock"></span>
			<span title="<?php _e( 'Unlocked','eos-dp' ); ?>" class="hover dashicons dashicons-unlock"></span>
			<span title="<?php _e( 'Included in the navigation','eos-dp' ); ?>" class="hover dashicons dashicons-menu-alt2"></span>
			<span title="<?php _e( 'Private','eos-dp' ); ?>" class="hover dashicons dashicons-privacy"></span>
			<?php
			if( function_exists( 'eos_scfm_post_types' ) ){ ?>
				<span title="<?php _e( 'Mobile','eos-dp' ); ?>" class="hover dashicons dashicons-smartphone"></span>
			<?php } ?>
			<?php if( class_exists( 'WooCommerce') && 'page' === $post_type){ ?>
			<span title="<?php _e( 'WooCommerce pages','eos-dp' ); ?>" class="hover dashicons dashicons-cart"></span>
		<?php } ?>
		</div>
		<div>
		<?php if( $is_home  ){ ?>
			<span id="eos-dp-autosuggest-all" class="button"><?php _e( 'Suggest plugins','eos-dp' ); ?></span>
		<?php }
		if( !$fdp_is_single_post ){
		?>
			<span id="eos-dp-lock-all" class="button<?php echo $is_home ? ' eos-hidden' : ''; ?>">
				<?php esc_html_e( 'Lock all','eos-dp-pro' ); ?>
				<span class="eos-post-locked-icon" style="width:14px;height:14px;transform:scale(1);transform-origin:0px 0px;display:inline-block;margin:0 4px"></span>
			</span>
			<span id="eos-dp-unlock-all" class="button<?php echo $is_home ? ' eos-hidden' : ''; ?>">
				<?php esc_html_e( 'Unlock all','eos-dp-pro' ); ?>
				<span class="eos-post-unlocked-icon" style="width:14px;height:14px;transform:scale(1);transform-origin:0px 0px;display:inline-block;margin:0 4px"></span>
			</span>

		<?php
		}
		if( $is_home  ){ ?>
			<p><?php printf( __( 'Pressing the button above, FDP will suggest you the needed plugins. However, check the page preview with the lens icon %s before to save the options.','eos-dp' ),'<span class="dashicons dashicons-search"></span>' ); ?></p>
		<?php }	?>
			<p id="eos-dp-autosuggest-msg" class="eos-hidden"><?php _e( 'It may take a couple of minutes, drink a coffee while we try to understand which plugins you need on this page','eos-dp' ); ?></p>
			<p id="eos-dp-autosuggest-msg-error" class="notice notice-error eos-hidden"><?php _e( 'Unable to finish the tests to suggest the unused plugins. Probably the server is too busy.','eos-dp' ); ?></p>
		</div>
		<?php if( $is_home  ){ ?>
		<div style="margin-bottom:12px;margin-top:32px">
			<span class="eos-dp-active-wrp eos-dp-icon-wrp"><input style="width:20px;height:20px;margin:0" type="checkbox" /></span>
			<span class="eos-dp-legend-txt"><?php _e( 'Plugin active','eos-dp' ); ?></span>
			<span class="eos-dp-not-active-wrp eos-dp-icon-wrp"><input style="width:20px;height:20px;margin:0" type="checkbox" checked/></span>
			<span class="eos-dp-legend-txt"><?php _e( 'Plugin not active','eos-dp' ); ?></span>
		</div>
		<?php }	?>
		<?php do_action( 'eos_dp_after_singles_title' ); ?>
		<div id="eos-dp-table-head-actions"><?php do_action( 'eos_dp_pre_table_head' ); ?></div>
			<?php eos_dp_plugin_names_orientation_ctrl(); ?>
			<table id="eos-dp-setts" data-post_type="<?php echo $post_type; ?>" data-zoom="1">
				<tbody>
				<tr id="eos-dp-table-head">
					<th style="vertical-align:top;background:transparent;border-style:none;text-align:initial">
						<div style="margin-bottom:12px;margin-top:12px">
							<span class="eos-dp-locked-wrp eos-dp-icon-wrp"><span class="eos-post-locked-icon" style="width:20px;height:20px"></span>
							<span class="eos-dp-help eos-dp-legend-txt" title="<?php _e( 'The Post Types Settings will never override the locked row options','eos-dp' ); ?>">?</span>
						</div>
						<div style="margin-bottom:12px">
							<span class="eos-dp-unlocked-wrp eos-dp-icon-wrp"><span class="eos-post-unlocked-icon" style="width:20px;height:20px"></span>
							<span class="eos-dp-help eos-dp-legend-txt" title="<?php _e( 'The Post Types Settings may override the unlocked row options','eos-dp' ); ?>">?</span>
						</div>
						<div style="margin-bottom:12px;margin-top:32px">
							<span class="eos-dp-active-wrp eos-dp-icon-wrp"><input style="width:20px;height:20px" type="checkbox" /></span>
							<span class="eos-dp-legend-txt"><?php _e( 'Plugin active','eos-dp' ); ?></span>
						</div>
						<div>
							<span class="eos-dp-not-active-wrp eos-dp-icon-wrp"><input style="width:20px;height:20px" type="checkbox" checked/></span>
							<span class="eos-dp-legend-txt"><?php _e( 'Plugin not active','eos-dp' ); ?></span>
						</div>
						<div style="margin-top:8px;margin-bottom:16px">
							<span style="margin:0;font-size:20px eos-dp-icon-wrp" title="<?php __( 'Restore last saved options','eos-dp' ); ?>" class="dashicons dashicons-image-rotate"></span>
							<span class="eos-dp-legend-txt"><?php _e( 'Back to last saved settings','eos-dp' ); ?></span>
						</div>
					</th>
					<?php
					$n = 0;
					foreach( $active_plugins as $plugin ){
						if( in_array( $plugin,array_keys( $plugins_by_dirs ) ) ){
							$plugin_name = strtoupper( str_replace( '-',' ',dirname( $plugin ) ) );
							$plugin_name_short = substr( $plugin_name,0,25 );
							$plugin_name_short = $plugin_name === $plugin_name_short ? $plugin_name : $plugin_name_short.' ...';
							$details_url = add_query_arg(
								array(
									'tab' => 'plugin-information',
									'plugin' => dirname( $plugin ),
									'TB_iframe' => true,
									'eos_dp' => $plugin,
									'eos_dp_info' => 'true'
								),
								admin_url( 'plugin-install.php' )
							);
							?>
							<th class="eos-dp-name-th">
								<div>
									<div id="eos-dp-plugin-name-<?php echo $n + 1; ?>" class="eos-dp-plugin-name" data-path="<?php echo $plugin; ?>">
										<span><a title="<?php printf( esc_attr__( 'View details of %s','eos-dp' ),esc_attr( $plugin_name ) ); ?>" href="<?php echo esc_url( $details_url ); ?>" target="_blank"><?php echo esc_html( $plugin_name_short ); ?></a></span>
									</div>
									<div class="eos-dp-global-chk-col-wrp">
										<div class="eos-dp-not-active-wrp"><input title="<?php printf( __( 'Activate/deactivate %s everywhere','eos-dp' ),esc_attr( $plugin_name ) ); ?>" data-col="<?php echo $n + 1; ?>" class="eos-dp-global-chk-col" type="checkbox" /></div>
										<div class="eos-dp-reset-col" data-col="<?php echo $n + 1; ?>"><span title="<?php printf( __( 'Restore last saved options for %s everywhere','eos-dp' ),esc_attr( $plugin_name ) ); ?>" class="dashicons dashicons-image-rotate"></span></div>
										<?php do_action( 'eos_dp_table_head_col_after' ); ?>
									</div>
								</div>
							</th>
							<?php
							++$n;
						}
					}
					?>
				</tr>
			<?php
				if( $fdp_is_single_post ){
					$row = 1;
				?>
				<h2><?php echo get_the_title( absint( $single_post_id ) ); ?></h2>
				<div style="margin:32px 0 16px 0;text-align:<?php echo is_rtl() ? 'left' : 'right'; ?>">
					<span id="fdp-select-all-single-post" class="button"><?php _e( 'Enable All','eos-dp' ); ?></span>
					<span id="fdp-unselect-all-single-post" class="button"><?php _e( 'Disable All','eos-dp' ); ?></span>
					<?php if( defined( 'EOS_DP_PRO_VERSION' ) ){ ?>
					<span data-id="<?php echo esc_attr( implode( '_',$_GET ) ); ?>" title="<?php esc_attr_e( 'Fill the table with the last saved options.','eos-dp-pro' ); ?>" id="eos-dp-restore-options" class="button"><?php _e( 'Restore saved options','eos-dp' ); ?></span>
					<?php } ?>
					<?php do_action( 'eos_dp_after_table_bulk_actions' ); ?>
				</div>
				<?php
					$args = array( 'test_id'=>time(),'fdp_post_id'=>$single_post_id );
					require_once EOS_DP_PLUGIN_DIR.'/admin/templates/partials/eos-dp-action-buttons.php';
				}
				?>
				<?php
				if( $posts && !empty( $posts ) ){
					$row = 1;
					foreach( $posts as $post ){
						if( $post->post_type === $post_type ){
							$desktop_id = 0;
							$mobileClass = '';
							if( in_array( $post_type,array( 'post','page' ) ) ){
								if( function_exists( 'eos_scfm_related_desktop_id' ) ){
									$desktop_id = eos_scfm_related_desktop_id( $post->ID );
									if( $desktop_id > 0 ){
										$mobileClass = ' eos-dp-mobile';
									}
								}
							}
							$values_string = isset( $meta_values[$post->ID] ) ? $meta_values[$post->ID] : '';
							$values = explode( ',',$values_string );
							$bin = substr( implode( '',array_map( 'eos_dp_is_not_empty_string',$values ) ),1 );
							$loc = false;
							$flag = '';
							if( function_exists( 'pll_get_post_language' ) ){
									$loc = pll_get_post_language( $post->ID );
									if( $loc && '' !== $loc ){
										$flag = defined( 'POLYLANG_FILE' ) && defined( 'POLYLANG_DIR' ) && file_exists( POLYLANG_DIR.'/flags/'.$loc.'.png' ) ? '<img src="'.esc_url( plugins_url( '/flags/'.$loc.'.png',POLYLANG_FILE ) ).'" />' : esc_html( strtoupper( $loc ) );
									}

							}
							elseif( defined( 'ICL_SITEPRESS_VERSION' ) ){
								$lang_info = apply_filters( 'wpml_post_language_details',null,$post->ID );
								if( !is_wp_error( $lang_info ) && is_array( $lang_info ) && isset( $lang_info['locale'] ) ){
									$loc = $lang_info['language_code'];
									if( $loc && '' !== $loc ){
										$flag = defined( 'ICL_PLUGIN_URL' ) && defined( 'WPML_PLUGIN_PATH' ) && file_exists( WPML_PLUGIN_PATH.'/res/flags/'.$loc.'.png' ) ? '<img src="'.esc_url( ICL_PLUGIN_URL.'/res/flags/'.$loc.'.png' ).'" />' : esc_html( strtoupper( $loc ) );
									}
								}
							}
							$needCustom = false;
							if( $loc && strtolower( substr( $loc,0,2 ) ) !== strtolower( substr( $default_language,0,2 ) ) ){
								$need_custom_url[$post->ID] = get_permalink( $post->ID );
								$needCustom = true;
							}
							$locked = '';
							if( isset( $post_types_matrix_pt[3] ) && is_array( $post_types_matrix_pt[3] ) && !empty( $post_types_matrix_pt[3] ) && in_array( $post->ID,$post_types_matrix_pt[3] ) ){
								$locked = ' eos-post-locked';
							}
							if( $needCustom && !empty( $eos_dp_need_custom_url ) && !in_array( $post->ID,array_keys( $eos_dp_need_custom_url ) ) ){
								$locked = '';
							}
							$args = array( 'test_id'=>time(),'fdp_post_id'=>$post->ID );
							if( !isset( $_GET['lang'] ) || ( $loc && $loc === $_GET['lang'] ) ){
								$woo = isset( $important_pages['woo_ids'] ) && !empty( $important_pages['woo_ids'] ) && in_array( $post->ID,$important_pages['woo_ids'] );
						?>
							<tr data-bin="<?php echo esc_attr( $bin ); ?>" class="eos-dp-post-row eos-dp-post-<?php echo $post_type.$mobileClass.$locked;echo $woo ? ' eos-dp-woo-row' : '';echo isset( $status_icons[$post->post_status] ) ? ' fdp-row-'.$post->post_status : '';echo isset( $important_pages['nav_ids'] ) && !empty( $important_pages['nav_ids'] ) && in_array( $post->ID,$important_pages['nav_ids'] ) ? ' fdp-in-nav' : '';?>" data-post-id="<?php echo $post->ID; ?>" data-row_id="<?php echo esc_attr( $post->ID ); ?>">
								<?php
								if( isset( $post->post_title ) ){
									?>
									<td class="eos-dp-post-name-wrp">
										<span class="eos-dp-lock-post-wrp"><input title="<?php printf( __( 'If locked the Post Types Settings will never override these row options for %s','eos-dp' ),esc_attr( $post->post_title ) ); ?>" data-row="<?php echo esc_attr( $row ); ?>" class="eos-dp-lock-post" type="checkbox" /></span>
										<span class="eos-dp-not-active-wrp"><input title="<?php printf( __( 'Activate/deactivate all plugins in %s','eos-dp' ),esc_attr( $post->post_title ) ); ?>" data-row="<?php echo esc_attr( $row ); ?>" class="eos-dp-global-chk-row" type="checkbox" /></span>
										<span class="eos-dp-title"><?php echo '' !== $post->post_title ? esc_html( $post->post_title ) : sprintf( __( 'Untitled (post id:%s)','eos-dp' ),$post->ID );echo isset( $status_icons[$post->post_status] ) ? $status_icons[$post->post_status] : '';echo $woo ? '<span title="'.__( 'WooCommerce page','eos-dp' ).'" class="dashicons dashicons-cart"></span>' : ''; echo isset( $important_pages['nav_ids'] ) && !empty( $important_pages['nav_ids'] ) && in_array( $post->ID,$important_pages['nav_ids'] ) ? '<span title="'.__( 'Included in the navigation','eos-dp' ).'" class="dashicons dashicons-menu-alt2"></span>' : '';?>
										<?php
										if( $desktop_id > 0 ){
											$desktop_title = get_the_title( $desktop_id );
											?><span title="<?php printf( __( 'Mobile version of %s','eos-dp' ),$desktop_title ); ?>" class="eos-dp-mobile dashicons dashicons-smartphone"></span><?php
										}
										?><span><?php echo $flag; ?></span>
										</span>
										<?php
										if( !$fdp_is_single_post ){
											include EOS_DP_PLUGIN_DIR.'/admin/templates/partials/eos-dp-action-buttons.php';
										}
										?>

									</td>
									<?php
									$k = 0;
									foreach( $active_plugins as $plugin ){
										if( in_array( $plugin,array_keys( $plugins_by_dirs ) ) ){
										?>
										<td data-path="<?php echo esc_attr( $plugin ); ?>" class="center<?php echo !in_array( $plugin,$values ) ? ' eos-dp-active' : ''; ?>">
											<div class="eos-dp-td-chk-wrp">
												<input class="eos-dp-row-<?php echo $row; ?> eos-dp-col-<?php echo $k + 1; ?> eos-dp-col-<?php echo ( $k + 1 ).'-'.$post_type; ?>" data-checked="<?php echo in_array( $plugin,$values ) ? 'checked' : 'not-checked'; ?>" type="checkbox"<?php echo in_array( $plugin,$values ) ? ' checked' : ''; ?> />
											</div>
										</td>
										<?php
										++$k;
										}
									}
								} ?>
							</tr>
							<?php
							++$row;
							}
						}
					}
				}
			?>
			</tbody>
			</table>
			<?php
			eos_dp_save_button(); ?>
	</section>
	<?php if( !empty( $need_custom_url ) ){ ?>
	<script>
	var eos_dp_need_custom_url = <?php echo wp_json_encode( $need_custom_url ); ?>;
	</script>
	<?php }
}
