<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
//It displays the admin navigation
function eos_dp_navigation(){
	$plugins_table = eos_dp_plugins_table();
	$post_types = array_keys( $plugins_table );
	$show_on_front = eos_dp_get_option( 'show_on_front' );
	if( 'page' === $show_on_front ){
		$page = 'eos_dp_menu';
		$sec = 'by-posts';
	}
	elseif( 'posts' === $show_on_front ){
		$page = 'eos_dp_by_archive';
		$sec = 'archives';
	}
	$plugins_integration = eos_dp_plugins_integration();
	$pro = defined( 'EOS_DP_PRO_VERSION' ) ? ', PRO v'.EOS_DP_PRO_VERSION : '';
	?>
	<div class="eos-pre-nav">
		<h3>
			<a style="text-decoration:none;color:inherit" href="https://freesoul-deactivate-plugins.com/" target="_blank" rel="noopener">
				<span class="dashicons dashicons-plugins-checked"></span> <?php printf( 'Freesoul Deactivate Plugins v%s%s',EOS_DP_VERSION,$pro ); ?>
			</a>
		</h3>
		<div id="eos-dp-before-nav">
			<ul id="eos-dp-pre-nav">
				<li data-section="eos-dp-control-panel-section" class="eos-dp-has-children hover<?php echo eos_dp_is_deactivation_page() || in_array( $_GET['page'],array( 'eos_dp_pro_settings','eos_dp_roles_manager','eos_dp_firing_order' ) ) ? ' eos-active' : ''; ?>  eos-dp-setts-menu-item">
					<a href="<?php echo admin_url( 'admin.php?page=eos_dp_by_post_type' ); ?>"><span title="<?php esc_attr_e( 'Settings','eos-dp' ); ?>" class="dashicons dashicons-admin-generic"></span><?php esc_html_e( 'Settings','eos-dp' ); ?></a>
					<ul id="eos-dp-main-settings" class="eos-dp-sub-menu">
						<li class="hover<?php echo eos_dp_is_deactivation_page() ? ' eos-active' : ''; ?>  eos-dp-setts-menu-item">
							<a href="<?php echo admin_url( 'admin.php?page=eos_dp_by_post_type' ); ?>" title="<?php esc_attr_e( 'Disable plugins','eos-dp' ); ?>"><span class="dashicons dashicons-plugins-checked"></span><?php _e( 'Plugins Deactivation','eos-dp' ); ?></a>
						</li>
						<li class="eos-dp-submenu-item hover<?php echo isset( $_GET['page'] ) && 'eos_dp_pro_settings' === $_GET['page'] ? ' eos-dp-current-submenu' : '';echo '' === $pro ? ' fdp-pro-feature' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_pro_settings' ); ?>"><?php esc_html_e( 'Events','eos-dp' ); ?></a></li>
						<?php if( current_user_can( 'manage_options' ) ) { ?>
						<li class="eos-dp-submenu-item hover<?php echo isset( $_GET['page'] ) && 'eos_dp_roles_manager' === $_GET['page'] ? ' eos-dp-current-submenu' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_roles_manager' ); ?>"><?php esc_html_e( 'Roles Manager','eos-dp' ); ?></a></li>
						<?php } ?>
						<li class="hover<?php echo $_GET['page'] === 'eos_dp_firing_order' ? ' eos-dp-current-submenu' : ''; ?>">
							<a href="<?php echo admin_url( 'admin.php?page=eos_dp_firing_order' ); ?>" title="<?php esc_attr_e( 'Firing Order','eos-dp' ); ?>"><?php _e( 'Firing Order','eos-dp' ); ?></a>
						</li>
						<li class="hover<?php echo '' === $pro ? ' fdp-pro-feature' : ''; ?>">
							<a href="<?php echo add_query_arg( 'fdp-hooks','actions',home_url() ); ?>" title="<?php esc_attr_e( 'Hooks deactivation','eos-dp' ); ?>" target="_blank"><?php _e( 'Hooks deactivation','eos-dp' ); ?></a>
						</li>
					</ul>
				</li>
				<li data-section="eos-dp-control-panel-section" class="eos-dp-has-children hover<?php echo in_array( $_GET['page'],array( 'eos_dp_pro_import_export','eos_dp_pro_bulk_actions','eos_dp_create_plugin','eos_dp_favorite_plugins' ) ) ? ' eos-active' : ''; ?>  eos-dp-setts-menu-item">
					<a href="<?php echo admin_url( 'tools.php?page=eos_dp_pro_import_export' ); ?>"><span title="<?php esc_attr_e( 'Tools','eos-dp' ); ?>" class="dashicons dashicons-admin-tools"></span><?php esc_html_e( 'Tools','eos-dp' ); ?></a>
					<ul id="eos-dp-import-export-sub" class="eos-dp-sub-menu">
						<li class="eos-dp-submenu-item hover<?php echo isset( $_GET['page'] ) && 'eos_dp_pro_import_export' === $_GET['page'] ? ' eos-dp-current-submenu' : '';echo '' === $pro ? ' fdp-pro-feature' : ''; ?>"><a href="<?php echo admin_url( 'tools.php?page=eos_dp_pro_import_export' ); ?>"><?php esc_html_e( 'Import/Export','eos-dp' ); ?></a></li>
						<li class="eos-dp-submenu-item hover<?php echo isset( $_GET['page'] ) && 'eos_dp_pro_bulk_actions' === $_GET['page'] ? ' eos-dp-current-submenu' : '';echo '' === $pro ? ' fdp-pro-feature' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_pro_bulk_actions' ); ?>"><?php esc_html_e( 'Bulk actions','eos-dp' ); ?></a></li>
						<?php if( current_user_can( 'manage_options' ) ) { ?>
						<li class="eos-dp-submenu-item hover<?php echo isset( $_GET['page'] ) && 'eos_dp_create_plugin' === $_GET['page'] ? ' eos-dp-current-submenu' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_create_plugin' ); ?>"><?php esc_html_e( 'Create custom plugin','eos-dp' ); ?></a></li>
						<?php } ?>
						<li class="eos-dp-submenu-item hover<?php echo isset( $_GET['page'] ) && 'eos_dp_favorite_plugins' === $_GET['page'] ? ' eos-dp-current-submenu' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_favorite_plugins' ); ?>"><?php esc_html_e( 'Favorite plugins','eos-dp' );echo ' (beta)'; ?></a></li>
					</ul>
				</li>
				<?php do_action( 'eos_dp_before_tabs' ); ?>
				<li class="eos-dp-has-children hover<?php echo in_array( $_GET['page'],array( 'eos_dp_testing','eos_dp_smoke_tests','eos_dp_report' ) )? ' eos-active' : ''; ?>  eos-dp-setts-menu-item">
					<a href="<?php echo admin_url( 'admin.php?page=eos_dp_smoke_tests' ); ?>" title="<?php esc_attr_e( 'Testing','eos-dp' ); ?>"><span class="dashicons dashicons-info"></span><?php _e( 'Testing','eos-dp' ); ?></a>
					<ul class="eos-dp-sub-menu">
						<li class="hover<?php echo $_GET['page'] === 'eos_dp_smoke_tests' ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_smoke_tests' ); ?>"><?php _e( 'Plugin Tests','eos-dp' ); ?></a></li>
						<li class="hover<?php echo isset( $_GET['page'] ) && 'eos_dp_testing' === $_GET['page'] ? ' eos-dp-current-submenu' : '';echo '' === $pro ? ' fdp-pro-feature' : ''; ?>"><a href="<?php echo add_query_arg( 'page','eos_dp_testing',admin_url( 'admin.php?page=eos_dp_testing' ) ); ?>"><?php esc_html_e( 'GTMetrix Settings','eos-dp' ); ?></a></li>
						<li class="hover<?php echo isset( $_GET['page'] ) && 'eos_dp_report' === $_GET['page'] ? ' eos-dp-current-submenu' : '';echo '' === $pro ? ' fdp-pro-feature' : ''; ?>"><a href="<?php echo add_query_arg( 'page','eos_dp_report',admin_url( 'admin.php?page=eos_dp_report' ) ); ?>"><?php esc_html_e( 'Reports','eos-dp' ); ?></a></li>
					</ul>
				</li>
				<li class="eos-dp-has-children hover<?php echo $_GET['page'] === 'eos_dp_help' ? ' eos-active' : ''; ?>  eos-dp-setts-menu-item" title="<?php esc_attr_e( 'Help','eos-dp' ); ?>">
					<a href="<?php echo admin_url( 'admin.php?page=eos_dp_help&tab=common_issues' ); ?>"><span title="<?php esc_attr_e( 'Help','eos-dp' ); ?>" class="dashicons dashicons-editor-help"></span><?php _e( 'Help','eos-dp'); ?></a>
					<ul class="eos-dp-sub-menu">
						<li class="hover<?php echo isset( $_GET['tab'] ) && 'common_issues' === $_GET['tab'] ? ' eos-active' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_help&tab=common_issues' ); ?>"><?php _e( 'Common issues','eos-dp' ); ?></a></li>
						<li class="hover<?php echo isset( $_GET['tab'] ) && 'flowchart' === $_GET['tab'] ? ' eos-active' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_help&tab=flowchart' ); ?>"><?php _e( 'Options priorities','eos-dp' ); ?></a></li>
						<li class="hover"><a target="_blank" rel="noopener" href="https://freesoul-deactivate-plugins.com/how-deactivate-plugiins-on-specific-pages/"><?php _e( 'Documentation','eos-dp' ); ?></a></li>
						<li class="hover"><a target="_blank" rel="noopener" href="https://wordpress.org/support/plugin/freesoul-deactivate-plugins/"><?php _e( 'Support Forum','eos-dp' ); ?></a></li>
						<li class="hover<?php echo '' === $pro ? ' fdp-pro-feature' : ''; ?>"><a target="_blank" rel="noopener" href="https://freesoul-deactivate-plugins.com/plugins/log-a-support-ticket/"><?php _e( 'Premium Support','eos-dp' ); ?></a></li>
					</ul>
				</li>
				<li></li>
			</ul>
		</div>
	</div>
	<div id="eos-dp-setts-nav-wrp">
		<ul id="eos-dp-setts-nav">
			<li class="eos-dp-setts-menu-item"><span class="dashicons dashicons-plugins-checked"></span></li>
			<li data-section="eos-dp-<?php echo $sec; ?>" class="hover<?php echo $_GET['page'] === $page && isset( $_GET['eos_dp_home'] ) && 'true' === $_GET['eos_dp_home'] ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page='.$page.'&eos_dp_home=true' ); ?>"><?php _e( 'Homepage','eos-dp' ); ?></a></li>
			<li data-section="eos-dp-control-panel-section" class="eos-dp-has-children hover<?php echo $_GET['page'] === 'eos_dp_menu' && !isset( $_GET['eos_dp_home'] ) ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_menu' ); ?>"><?php _e( 'Singles','eos-dp' ); ?></a>
				<?php
				if( !empty( $plugins_table ) ){
				?>
				<span class="dashicons dashicons-arrow-down"></span>
				<ul id="eos-dp-singles-sub" class="eos-dp-sub-menu">
				<?php
				foreach( $plugins_table as $pt  => $arr ){
					$postTypeObj = get_post_type_object( $pt );
					if( !in_array( $pt,array( 'attachment' ) ) && is_object( $postTypeObj ) ){
						$labels = get_post_type_labels( $postTypeObj );
						$labels_name = isset( $labels->name ) ? $labels->name : esc_html( $pt );
						?>
						<li class="eos-dp-submenu-item<?php echo isset( $_GET['eos_dp_post_type'] ) && $pt === $_GET['eos_dp_post_type'] ? ' eos-dp-current-submenu' : ''; ?>" data-post-type="<?php echo esc_attr( $pt ); ?>">
							<?php if( in_array( $pt,array( 'page','post' ) ) ){ ?>
							<span class="dashicons dashicons-admin-<?php echo esc_attr( $pt ); ?>"></span>
							<?php }elseif( 'product' === $pt ){ ?>
							<span class="dashicons dashicons-cart"></span>
							<?php }elseif( 'event' === $pt ){ ?>
							<span class="dashicons dashicons-calendar"></span>
							<?php } ?>
							<a class="eos-dp-single-item-<?php echo esc_attr( $pt ); ?>" href="<?php echo add_query_arg( 'eos_dp_post_type',esc_attr( $pt ),admin_url( 'admin.php?page=eos_dp_menu' ) ); ?>"><?php echo esc_html( $labels_name ); ?></a>
						<?php
						if( 'page' === $pt ){
						?>
						<span class="dashicons dashicons-arrow-right"></span>
						<ul class="eos-dp-sub-menu">
							<li class="eos-dp-sub-sub-menu<?php echo isset( $_GET['eos_dp_relevant_pages'] ) && 'true' === $_GET['eos_dp_relevant_pages'] ? ' eos-active' : ''; ?>"><a href="<?php echo add_query_arg( array( 'eos_dp_relevant_pages' => 'true','eos_dp_post_type' => 'page' ),admin_url( 'admin.php?page=eos_dp_menu' ) ); ?>"><?php _e( 'Relevant pages','eos-dp' ); ?></a></li>
						</ul>
						<?php
						}
						?>
						</li>
						<?php
					}
				}
				?>
				</ul>
				<?php
				}
				?>
			</li>
			<li data-section="eos-dp-by-posts" class="hover<?php echo $_GET['page'] === 'eos_dp_by_post_type' ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_by_post_type' ); ?>"><?php _e( 'Post Types','eos-dp' ); ?></a></li>
			<li data-section="eos-dp-archives" class="hover<?php echo $_GET['page'] === 'eos_dp_by_archive' ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_by_archive' ); ?>"><?php _e( 'Archives','eos-dp' ); ?></a></li>
			<li data-section="eos-dp-term-archives" class="eos-dp-has-children hover<?php echo $_GET['page'] === 'eos_dp_by_term_archive' ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_by_term_archive' ); ?>"><?php _e( 'Terms Archives','eos-dp' ); ?></a>
				<?php
				$taxs = get_taxonomies( array(),'objects' );
				if( $taxs ){
				?>
				<span class="dashicons dashicons-arrow-down"></span>
				<ul id="eos-dp-taxs-sub" class="eos-dp-sub-menu">
				<?php
					foreach( $taxs as $tax ){
						if( '1' == $tax -> public && isset( $tax -> object_type ) ){
							$show = false;
							$labels_names = array();
							foreach( $tax -> object_type as $term_post_type ){
								if( in_array( $term_post_type,$post_types ) ){
									$show = true;
									$postTypeObj = get_post_type_object( $term_post_type );
									$labels = get_post_type_labels( $postTypeObj );
									$labels_names[] = isset( $labels->name ) ? $labels->name : $term_post_type;
								}
							}
							if( $show ){
								?>
								<li class="eos-dp-submenu-item<?php echo isset( $_GET['eos_dp_tax'] ) && $tax->name === $_GET['eos_dp_tax'] ? ' eos-dp-current-submenu' : ''; ?>"><a href="<?php echo add_query_arg( 'eos_dp_tax',$tax -> name,admin_url( 'admin.php?page=eos_dp_by_term_archive' ) ); ?>"><?php printf( __( '%s (%s)','eos-dp' ),esc_html( $tax -> label ),esc_html( implode( ',',$labels_names ) ) ); ?></a></li>
								<?php
							}
						}
					}
				?>
				</ul>
				<?php
				}
				?>
			</li>
			<li data-section="eos-dp-term-mobile" class="hover<?php echo $_GET['page'] === 'eos_dp_mobile' ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_mobile' ); ?>"><?php _e( 'Mobile','eos-dp' ); ?></a></li>
			<li data-section="eos-dp-search" class="hover<?php echo $_GET['page'] === 'eos_dp_search' ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_search' ); ?>"><?php _e( 'Search','eos-dp' ); ?></a></li>
			<li data-section="eos-dp-url" class="eos-dp-has-children hover<?php echo in_array( $_GET['page'],array( 'eos_dp_url','eos_dp_admin_url' ) ) ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_url' ); ?>"><?php _e( 'Custom URLs','eos-dp' ); ?></a>
				<span class="dashicons dashicons-arrow-down"></span>
				<ul class="eos-dp-sub-menu">
					<li data-section="eos-dp-url" class="eos-dp-submenu-item hover<?php echo $_GET['page'] === 'eos_dp_url' ? ' eos-active' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_url' ); ?>"><?php _e( 'Frontend URLs','eos-dp' ); ?></a></li>
					<li data-section="eos-dp-admin-url" class="eos-dp-submenu-item hover<?php echo $_GET['page'] === 'eos_dp_admin_url' ? ' eos-active' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_admin_url' ); ?>"><?php _e( 'Backend URLs','eos-dp' ); ?></a></li>
				</ul>
			</li>
			<li data-section="eos-dp-admin" class="eos-dp-has-children hover<?php echo in_array( $_GET['page'],array( 'eos_dp_admin','eos_dp_admin_url' ) )  ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_admin' ); ?>"><?php _e( 'Backend','eos-dp' ); ?></a>
				<span class="dashicons dashicons-arrow-down"></span>
				<ul class="eos-dp-sub-menu">
					<li data-section="eos-dp-admin" class="hover<?php echo $_GET['page'] === 'eos_dp_admin' ? ' eos-active' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_admin' ); ?>"><?php _e( 'Backend Singles','eos-dp' ); ?></a></li>
					<li data-section="eos-dp-admin-url" class="eos-dp-submenu-item hover<?php echo $_GET['page'] === 'eos_dp_admin_url' ? ' eos-active' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_admin_url' ); ?>"><?php _e( 'Backend URLs','eos-dp' ); ?></a></li>
				</ul>
			</li>
			<li data-section="eos-dp-integration" class="eos-dp-has-children hover<?php echo $_GET['page'] === 'eos_dp_integration' ? ' eos-integration' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_integration&int_plugin=wordpress-core' );?>"><?php _e( 'Actions','eos-dp' ); ?></a>
			<?php
			if( $plugins_integration ){
			?>
				<span class="dashicons dashicons-arrow-down"></span>
				<ul class="eos-dp-sub-menu">
					<li data-section="eos-dp-control-panel-section" class="hover<?php echo $_GET['page'] === 'eos_dp_ajax' ? ' eos-active' : '';echo '' === $pro ? ' fdp-pro-feature' : ''; ?>"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_ajax&nopriv=true' ); ?>"><?php esc_html_e( 'Custom Ajax','eos-dp' ); ?></a></li>
				<?php
				do_action( 'eos_dp_actions_menu_items' );
				foreach( $plugins_integration as $plugin_slug => $arr ){
					if( $arr['is_active'] ){
				?>
					<li data-section="eos-dp-<?php echo $plugin_slug; ?>" class="eos-dp-submenu-item hover<?php echo $_GET['page'] === 'eos_dp_integration' && isset( $_GET['int_plugin'] ) && $plugin_slug === $_GET['int_plugin'] ? ' eos-active' : ''; ?>">
						<a href="<?php echo add_query_arg( array( 'page' => 'eos_dp_integration','int_plugin' => $plugin_slug ),admin_url( 'admin.php' ) ); ?>"><?php echo strtoupper( str_replace( '-',' ',$plugin_slug ) ); ?></a>
					</li>
				<?php
					}
				}
				?>
				</ul>
			<?php
			}
			?>
			</li>
			<li data-section="eos-dp-logged" class="eos-dp-has-children hover<?php echo in_array( $_GET['page'],array( 'eos_dp_logged' ) ) ? ' eos-active' : '';echo '' === $pro ? ' fdp-pro-feature' : ''; ?> eos-dp-setts-menu-item"><a href="<?php echo admin_url( 'admin.php?page=eos_dp_logged' ); ?>"><?php esc_html_e( 'Users','eos-dp' ); ?></a>
			<?php do_action( 'eos_dp_tabs' ); ?>
			<li></li>
		</ul>
	</div>
	<?php
	if( !in_array( $_GET['page'],array(
		'eos_dp_mobile',
		'eos_dp_search',
		'eos_dp_firing_order',
		'eos_dp_testing',
		'eos_dp_report',
		'eos_dp_help',
		'eos_dp_smoke_tests',
		'common_issues'
	) ) ){
	$active_plugins = count(eos_dp_get_option( 'active_plugins' ) ) - 1 - 1*defined( 'EOS_DP_PRO_VERSION' );
		if( $active_plugins > 40 ){
			$g = 30;
			$k = ceil( $active_plugins/$g );
			$l = 0;
			?>
			<div id="fdp-plugins-filters">
				<?php for( $n = 1;$n < $k + 1;++$n ){ ?>
				<span class="fdp-plug-filter button" data-min="<?php echo max( 1,( $l * $g ) ); ?>" data-max="<?php echo min( $active_plugins,( (  $n * $g ) - 1 ) ); ?>"><span class="dashicons dashicons-admin-plugins"  style="padding:4px 0"></span><?php printf( '%s - %s',max( 1,( $l * $g ) ),min( $active_plugins,( (  $n * $g ) - 1 ) ) ); ?></span>
				<?php $l = $n; } ?>
				<span id="fdp-plug-filter-all" class="fdp-plug-filter button" data-min="all"><span class="dashicons dashicons-admin-plugins" style="padding:4px 0"></span><?php esc_html_e( 'All','eos-dp' ); ?></span>
				<p><?php _e( 'Click on the buttons above to see less plugins on the screen.' ); ?></p>
		</div>
	<?php } } ?>
	<?php do_action( 'eos_dp_after_settings_nav' );
}
